<template>
  <div>
    <div v-if="stats">
      <div class="block col-md-2 offset-1">
        <span class="value">{{ stats.totalInstances | formatNumber }}</span>
        <span class="label">Instances</span>
      </div>

      <div class="block col-md-2 offset-2">
        <span class="value">{{ stats.totalUsers | formatNumber }}</span>
        <span class="label">Users</span>
      </div>

      <div class="block col-md-2 offset-2">
        <span class="value">{{ stats.totalGroups | formatNumber }}</span>
        <span class="label">Groups</span>
      </div>

      <div class="block col-md-2 offset-1">
        <span class="value">{{ stats.totalEvents | formatNumber }}</span>
        <span class="label">Events</span>
      </div>
    </div>

    <instance-stats-history class="instance-stats-history"></instance-stats-history>
  </div>
</template>

<style lang="scss">

  .block {
    display: inline-block;
    border-radius: 3px;
    background-color: #488bf7;
    color: #fff;
    margin-top: 15px;
    margin-bottom: 15px;
    padding-top: 30px;
    padding-bottom: 30px;

    .label, .value {
      display: block;
      text-align: center;
    }

    .label {
      text-transform: uppercase;
      font-size: 0.8em;
    }

    .value {
      font-weight: bold;
      font-size: 1.5em;
      margin-bottom: 10px;
    }
  }

  .instance-stats-history {
    margin-top: 50px;
  }

</style>

<script lang="ts">
  import { Component, Vue } from 'vue-property-decorator'

  import { InstanceStats as InstanceStatsModel } from '../../../shared/models/instance-stats.model'
  import { GlobalStats } from '../../../shared/models/global-stats.model'
  import { getInstanceStats } from '../shared/instance-http'

  import * as bytes from 'bytes'
  import InstanceStatsHistory from './InstanceStatsHistory.vue'

  @Component({
    components: {
      InstanceStatsHistory
    },
    filters: {
      formatNumber: (value: string) => value.toLocaleString(),

      formatBytes: (value: string) => bytes.format(parseInt(value, 10))
    }
  })
  export default class InstanceStats extends Vue {
    stats: GlobalStats = null

    async mounted () {
      this.stats = await getInstanceStats()
    }
  }
</script>
